Index: irmp.c
===================================================================
--- irmp.c	(Revision 191)
+++ irmp.c	(Arbeitskopie)
@@ -3923,8 +3946,8 @@ irmp_ISR (void)
 #endif // IRMP_SUPPORT_ORTEK_PROTOCOL == 1
 
 #if IRMP_SUPPORT_RCMM_PROTOCOL == 1
-                    if (irmp_pulse_time >= RCMM32_START_BIT_PULSE_LEN_MIN && irmp_pulse_time <= RCMM32_START_BIT_PULSE_LEN_MAX &&
-                        irmp_pause_time >= RCMM32_START_BIT_PAUSE_LEN_MIN && irmp_pause_time <= RCMM32_START_BIT_PAUSE_LEN_MAX)
+                    if (ir->isr.pulse_time >= RCMM32_START_BIT_PULSE_LEN_MIN && ir->isr.pulse_time <= RCMM32_START_BIT_PULSE_LEN_MAX &&
+                        ir->isr.pause_time >= RCMM32_START_BIT_PAUSE_LEN_MIN && ir->isr.pause_time <= RCMM32_START_BIT_PAUSE_LEN_MAX)
                     {                                                           // it's RCMM
 #ifdef ANALYZE
                         ANALYZE_PRINTF ("protocol = RCMM, start bit timings: pulse: %3d - %3d, pause: %3d - %3d\n",
@@ -3939,32 +3962,32 @@ irmp_ISR (void)
 #ifdef ANALYZE
                         ANALYZE_PRINTF ("protocol = UNKNOWN\n");
 #endif // ANALYZE
-                        irmp_start_bit_detected = 0;                            // wait for another start bit...
+                        ir->isr.start_bit_detected = 0;                            // wait for another start bit...
                     }
 
-                    if (irmp_start_bit_detected)
+                    if (ir->isr.start_bit_detected)
                     {
-                        memcpy_P (&irmp_param, irmp_param_p, sizeof (IRMP_PARAMETER));
+                        memcpy_P (&irmp.param, irmp_param_p, sizeof (IRMP_PARAMETER));
 
-                        if (! (irmp_param.flags & IRMP_PARAM_FLAG_IS_MANCHESTER))
+                        if (! (ir->param.flags & IRMP_PARAM_FLAG_IS_MANCHESTER))
                         {
 #ifdef ANALYZE
-                            ANALYZE_PRINTF ("pulse_1: %3d - %3d\n", irmp_param.pulse_1_len_min, irmp_param.pulse_1_len_max);
-                            ANALYZE_PRINTF ("pause_1: %3d - %3d\n", irmp_param.pause_1_len_min, irmp_param.pause_1_len_max);
+                            ANALYZE_PRINTF ("pulse_1: %3d - %3d\n", ir->param.pulse_1_len_min, ir->param.pulse_1_len_max);
+                            ANALYZE_PRINTF ("pause_1: %3d - %3d\n", ir->param.pause_1_len_min, ir->param.pause_1_len_max);
 #endif // ANALYZE
                         }
                         else
                         {
 #ifdef ANALYZE
-                            ANALYZE_PRINTF ("pulse: %3d - %3d or %3d - %3d\n", irmp_param.pulse_1_len_min, irmp_param.pulse_1_len_max,
-                                            2 * irmp_param.pulse_1_len_min, 2 * irmp_param.pulse_1_len_max);
-                            ANALYZE_PRINTF ("pause: %3d - %3d or %3d - %3d\n", irmp_param.pause_1_len_min, irmp_param.pause_1_len_max,
-                                            2 * irmp_param.pause_1_len_min, 2 * irmp_param.pause_1_len_max);
+                            ANALYZE_PRINTF ("pulse: %3d - %3d or %3d - %3d\n", ir->param.pulse_1_len_min, ir->param.pulse_1_len_max,
+                                            2 * ir->param.pulse_1_len_min, 2 * ir->param.pulse_1_len_max);
+                            ANALYZE_PRINTF ("pause: %3d - %3d or %3d - %3d\n", ir->param.pause_1_len_min, ir->param.pause_1_len_max,
+                                            2 * ir->param.pause_1_len_min, 2 * ir->param.pause_1_len_max);
 #endif // ANALYZE
                         }
 
 #if IRMP_SUPPORT_RC5_PROTOCOL == 1 && (IRMP_SUPPORT_FDC_PROTOCOL == 1 || IRMP_SUPPORT_RCCAR_PROTOCOL == 1)
-                        if (irmp_param2.protocol)
+                        if (ir->param2.protocol)
                         {
 #ifdef ANALYZE
                             ANALYZE_PRINTF ("pulse_0: %3d - %3d\n", irmp_param2.pulse_0_len_min, irmp_param2.pulse_0_len_max);
@@ -3977,7 +4000,7 @@ irmp_ISR (void)
 
 
 #if IRMP_SUPPORT_RC6_PROTOCOL == 1
-                        if (irmp_param.protocol == IRMP_RC6_PROTOCOL)
+                        if (ir->param.protocol == IRMP_RC6_PROTOCOL)
                         {
 #ifdef ANALYZE
                             ANALYZE_PRINTF ("pulse_toggle: %3d - %3d\n", RC6_TOGGLE_BIT_LEN_MIN, RC6_TOGGLE_BIT_LEN_MAX);
@@ -3985,71 +4008,71 @@ irmp_ISR (void)
                         }
 #endif
 
-                        if (! (irmp_param.flags & IRMP_PARAM_FLAG_IS_MANCHESTER))
+                        if (! (ir->param.flags & IRMP_PARAM_FLAG_IS_MANCHESTER))
                         {
 #ifdef ANALYZE
-                            ANALYZE_PRINTF ("pulse_0: %3d - %3d\n", irmp_param.pulse_0_len_min, irmp_param.pulse_0_len_max);
-                            ANALYZE_PRINTF ("pause_0: %3d - %3d\n", irmp_param.pause_0_len_min, irmp_param.pause_0_len_max);
+                            ANALYZE_PRINTF ("pulse_0: %3d - %3d\n", ir->param.pulse_0_len_min, ir->param.pulse_0_len_max);
+                            ANALYZE_PRINTF ("pause_0: %3d - %3d\n", ir->param.pause_0_len_min, ir->param.pause_0_len_max);
 #endif // ANALYZE
                         }
                         else
                         {
 #ifdef ANALYZE
-                            ANALYZE_PRINTF ("pulse: %3d - %3d or %3d - %3d\n", irmp_param.pulse_0_len_min, irmp_param.pulse_0_len_max,
-                                            2 * irmp_param.pulse_0_len_min, 2 * irmp_param.pulse_0_len_max);
-                            ANALYZE_PRINTF ("pause: %3d - %3d or %3d - %3d\n", irmp_param.pause_0_len_min, irmp_param.pause_0_len_max,
-                                            2 * irmp_param.pause_0_len_min, 2 * irmp_param.pause_0_len_max);
+                            ANALYZE_PRINTF ("pulse: %3d - %3d or %3d - %3d\n", ir->param.pulse_0_len_min, ir->param.pulse_0_len_max,
+                                            2 * ir->param.pulse_0_len_min, 2 * ir->param.pulse_0_len_max);
+                            ANALYZE_PRINTF ("pause: %3d - %3d or %3d - %3d\n", ir->param.pause_0_len_min, ir->param.pause_0_len_max,
+                                            2 * ir->param.pause_0_len_min, 2 * ir->param.pause_0_len_max);
 #endif // ANALYZE
                         }
 
 #ifdef ANALYZE
 #if IRMP_SUPPORT_BANG_OLUFSEN_PROTOCOL == 1
-                        if (irmp_param.protocol == IRMP_BANG_OLUFSEN_PROTOCOL)
+                        if (ir->param.protocol == IRMP_BANG_OLUFSEN_PROTOCOL)
                         {
-                            ANALYZE_PRINTF ("pulse_r: %3d - %3d\n", irmp_param.pulse_0_len_min, irmp_param.pulse_0_len_max);
+                            ANALYZE_PRINTF ("pulse_r: %3d - %3d\n", ir->param.pulse_0_len_min, ir->param.pulse_0_len_max);
                             ANALYZE_PRINTF ("pause_r: %3d - %3d\n", BANG_OLUFSEN_R_PAUSE_LEN_MIN, BANG_OLUFSEN_R_PAUSE_LEN_MAX);
                         }
 #endif
 
-                        ANALYZE_PRINTF ("command_offset: %2d\n", irmp_param.command_offset);
-                        ANALYZE_PRINTF ("command_len:    %3d\n", irmp_param.command_end - irmp_param.command_offset);
-                        ANALYZE_PRINTF ("complete_len:   %3d\n", irmp_param.complete_len);
-                        ANALYZE_PRINTF ("stop_bit:       %3d\n", irmp_param.stop_bit);
+                        ANALYZE_PRINTF ("command_offset: %2d\n", ir->param.command_offset);
+                        ANALYZE_PRINTF ("command_len:    %3d\n", ir->param.command_end - ir->param.command_offset);
+                        ANALYZE_PRINTF ("complete_len:   %3d\n", ir->param.complete_len);
+                        ANALYZE_PRINTF ("stop_bit:       %3d\n", ir->param.stop_bit);
 #endif // ANALYZE
                     }
 
-                    irmp_bit = 0;
+                    ir->bit = 0;
 
 #if IRMP_SUPPORT_MANCHESTER == 1
-                    if ((irmp_param.flags & IRMP_PARAM_FLAG_IS_MANCHESTER) &&
-                         irmp_param.protocol != IRMP_RUWIDO_PROTOCOL && // Manchester, but not RUWIDO
-                         irmp_param.protocol != IRMP_RC6_PROTOCOL /*** &&    // Manchester, but not RC6
-                         irmp_param.protocol != IRMP_RCII_PROTOCOL ****/)     // Manchester, but not RCII
+                    if ((ir->param.flags & IRMP_PARAM_FLAG_IS_MANCHESTER) &&
+                         ir->param.protocol != IRMP_RUWIDO_PROTOCOL && // Manchester, but not RUWIDO
+                         ir->param.protocol != IRMP_RC6_PROTOCOL /*** &&    // Manchester, but not RC6
+                         ir->param.protocol != IRMP_RCII_PROTOCOL ****/)     // Manchester, but not RCII
                     {
-                        if (irmp_pause_time > irmp_param.pulse_1_len_max && irmp_pause_time <= 2 * irmp_param.pulse_1_len_max)
+                        if (ir->isr.pause_time > ir->param.pulse_1_len_max && ir->isr.pause_time <= 2 * ir->param.pulse_1_len_max)
                         {
 #ifdef ANALYZE
-                            ANALYZE_PRINTF ("%8.3fms [bit %2d: pulse = %3d, pause = %3d] ", (double) (time_counter * 1000) / F_INTERRUPTS, irmp_bit, irmp_pulse_time, irmp_pause_time);
-                            ANALYZE_PUTCHAR ((irmp_param.flags & IRMP_PARAM_FLAG_1ST_PULSE_IS_1) ? '0' : '1');
+                            ANALYZE_PRINTF ("%8.3fms [bit %2d: pulse = %3d, pause = %3d] ", (double) (time_counter * 1000) / F_INTERRUPTS, ir->bit, ir->isr.pulse_time, ir->isr.pause_time);
+                            ANALYZE_PUTCHAR ((ir->param.flags & IRMP_PARAM_FLAG_1ST_PULSE_IS_1) ? '0' : '1');
                             ANALYZE_NEWLINE ();
 #endif // ANALYZE
-                            irmp_store_bit ((irmp_param.flags & IRMP_PARAM_FLAG_1ST_PULSE_IS_1) ? 0 : 1);
+                            irmp_store_bit ((ir->param.flags & IRMP_PARAM_FLAG_1ST_PULSE_IS_1) ? 0 : 1);
                         }
-                        else if (! last_value)  // && irmp_pause_time >= irmp_param.pause_1_len_min && irmp_pause_time <= irmp_param.pause_1_len_max)
+                        else if (! last_value)  // && ir->isr.pause_time >= ir->param.pause_1_len_min && ir->isr.pause_time <= ir->param.pause_1_len_max)
                         {
 #ifdef ANALYZE
-                            ANALYZE_PRINTF ("%8.3fms [bit %2d: pulse = %3d, pause = %3d] ", (double) (time_counter * 1000) / F_INTERRUPTS, irmp_bit, irmp_pulse_time, irmp_pause_time);
-                            ANALYZE_PUTCHAR ((irmp_param.flags & IRMP_PARAM_FLAG_1ST_PULSE_IS_1) ? '1' : '0');
+                            ANALYZE_PRINTF ("%8.3fms [bit %2d: pulse = %3d, pause = %3d] ", (double) (time_counter * 1000) / F_INTERRUPTS, ir->bit, ir->isr.pulse_time, ir->isr.pause_time);
+                            ANALYZE_PUTCHAR ((ir->param.flags & IRMP_PARAM_FLAG_1ST_PULSE_IS_1) ? '1' : '0');
                             ANALYZE_NEWLINE ();
 #endif // ANALYZE
-                            irmp_store_bit ((irmp_param.flags & IRMP_PARAM_FLAG_1ST_PULSE_IS_1) ? 1 : 0);
+                            irmp_store_bit ((ir->param.flags & IRMP_PARAM_FLAG_1ST_PULSE_IS_1) ? 1 : 0);
                         }
                     }
                     else
 #endif // IRMP_SUPPORT_MANCHESTER == 1
 
 #if IRMP_SUPPORT_SERIAL == 1
-                    if (irmp_param.flags & IRMP_PARAM_FLAG_IS_SERIAL)
+                    if (ir->param.flags & IRMP_PARAM_FLAG_IS_SERIAL)
                     {
                         ; // do nothing
                     }
@@ -4058,13 +4081,13 @@ irmp_ISR (void)
 
 
 #if IRMP_SUPPORT_DENON_PROTOCOL == 1
-                    if (irmp_param.protocol == IRMP_DENON_PROTOCOL)
+                    if (ir->param.protocol == IRMP_DENON_PROTOCOL)
                     {
 #ifdef ANALYZE
-                        ANALYZE_PRINTF ("%8.3fms [bit %2d: pulse = %3d, pause = %3d] ", (double) (time_counter * 1000) / F_INTERRUPTS, irmp_bit, irmp_pulse_time, irmp_pause_time);
+                        ANALYZE_PRINTF ("%8.3fms [bit %2d: pulse = %3d, pause = %3d] ", (double) (time_counter * 1000) / F_INTERRUPTS, ir->bit, ir->isr.pulse_time, ir->isr.pause_time);
 #endif // ANALYZE
 
-                        if (irmp_pause_time >= DENON_1_PAUSE_LEN_MIN && irmp_pause_time <= DENON_1_PAUSE_LEN_MAX)
+                        if (ir->isr.pause_time >= DENON_1_PAUSE_LEN_MIN && ir->isr.pause_time <= DENON_1_PAUSE_LEN_MAX)
                         {                                                       // pause timings correct for "1"?
 #ifdef ANALYZE
                             ANALYZE_PUTCHAR ('1');                                  // yes, store 1
@@ -4072,7 +4095,7 @@ irmp_ISR (void)
 #endif // ANALYZE
                             irmp_store_bit (1);
                         }
-                        else // if (irmp_pause_time >= DENON_0_PAUSE_LEN_MIN && irmp_pause_time <= DENON_0_PAUSE_LEN_MAX)
+                        else // if (ir->isr.pause_time >= DENON_0_PAUSE_LEN_MIN && ir->isr.pause_time <= DENON_0_PAUSE_LEN_MAX)
                         {                                                       // pause timings correct for "0"?
 #ifdef ANALYZE
                             ANALYZE_PUTCHAR ('0');                                  // yes, store 0
@@ -4084,13 +4107,13 @@ irmp_ISR (void)
                     else
 #endif // IRMP_SUPPORT_DENON_PROTOCOL == 1
 #if IRMP_SUPPORT_THOMSON_PROTOCOL == 1
-                    if (irmp_param.protocol == IRMP_THOMSON_PROTOCOL)
+                    if (ir->param.protocol == IRMP_THOMSON_PROTOCOL)
                     {
 #ifdef ANALYZE
-                        ANALYZE_PRINTF ("%8.3fms [bit %2d: pulse = %3d, pause = %3d] ", (double) (time_counter * 1000) / F_INTERRUPTS, irmp_bit, irmp_pulse_time, irmp_pause_time);
+                        ANALYZE_PRINTF ("%8.3fms [bit %2d: pulse = %3d, pause = %3d] ", (double) (time_counter * 1000) / F_INTERRUPTS, ir->bit, ir->isr.pulse_time, ir->isr.pause_time);
 #endif // ANALYZE
 
-                        if (irmp_pause_time >= THOMSON_1_PAUSE_LEN_MIN && irmp_pause_time <= THOMSON_1_PAUSE_LEN_MAX)
+                        if (ir->isr.pause_time >= THOMSON_1_PAUSE_LEN_MIN && ir->isr.pause_time <= THOMSON_1_PAUSE_LEN_MAX)
                         {                                                       // pause timings correct for "1"?
 #ifdef ANALYZE
                           ANALYZE_PUTCHAR ('1');                                  // yes, store 1
@@ -4098,7 +4121,7 @@ irmp_ISR (void)
 #endif // ANALYZE
                           irmp_store_bit (1);
                         }
-                        else // if (irmp_pause_time >= THOMSON_0_PAUSE_LEN_MIN && irmp_pause_time <= THOMSON_0_PAUSE_LEN_MAX)
+                        else // if (ir->isr.pause_time >= THOMSON_0_PAUSE_LEN_MIN && ir->isr.pause_time <= THOMSON_0_PAUSE_LEN_MAX)
                         {                                                       // pause timings correct for "0"?
 #ifdef ANALYZE
                           ANALYZE_PUTCHAR ('0');                                  // yes, store 0
@@ -4113,87 +4136,88 @@ irmp_ISR (void)
                         ;                                                       // else do nothing
                     }
 
-                    irmp_pulse_time = 1;                                        // set counter to 1, not 0
-                    irmp_pause_time = 0;
-                    wait_for_start_space = 0;
+                    ir->isr.pulse_time = 1;                                        // set counter to 1, not 0
+                    ir->isr.pause_time = 0;
+                    ir->isr.wait_for_start_space = 0;
                 }
             }
-            else if (wait_for_space)                                            // the data section....
+            else if (ir->isr.wait_for_space)                                            // the data section....
             {                                                                   // counting the time of darkness....
                 uint_fast8_t got_light = FALSE;
 
                 if (irmp_input)                                                 // still dark?
                 {                                                               // yes...
-                    if (irmp_bit == irmp_param.complete_len && irmp_param.stop_bit == 1)
+                    if (ir->bit == ir->param.complete_len && ir->param.stop_bit == 1)
                     {
                         if (
 #if IRMP_SUPPORT_MANCHESTER == 1
-                            (irmp_param.flags & IRMP_PARAM_FLAG_IS_MANCHESTER) ||
+                            (ir->param.flags & IRMP_PARAM_FLAG_IS_MANCHESTER) ||
 #endif
 #if IRMP_SUPPORT_SERIAL == 1
-                            (irmp_param.flags & IRMP_PARAM_FLAG_IS_SERIAL) ||
+                            (ir->param.flags & IRMP_PARAM_FLAG_IS_SERIAL) ||
 #endif
-                            (irmp_pulse_time >= irmp_param.pulse_0_len_min && irmp_pulse_time <= irmp_param.pulse_0_len_max))
+                            (ir->isr.pulse_time >= ir->param.pulse_0_len_min
+                             && ir->isr.pulse_time <= ir->param.pulse_0_len_max))
                         {
 #ifdef ANALYZE
-                            if (! (irmp_param.flags & IRMP_PARAM_FLAG_IS_MANCHESTER))
+                            if (! (ir->param.flags & IRMP_PARAM_FLAG_IS_MANCHESTER))
                             {
                                 ANALYZE_PRINTF ("stop bit detected\n");
                             }
 #endif // ANALYZE
-                            irmp_param.stop_bit = 0;
+                            ir->param.stop_bit = 0;
                         }
                         else
                         {
 #ifdef ANALYZE
-                            ANALYZE_PRINTF ("error: stop bit timing wrong, irmp_bit = %d, irmp_pulse_time = %d, pulse_0_len_min = %d, pulse_0_len_max = %d\n",
-                                            irmp_bit, irmp_pulse_time, irmp_param.pulse_0_len_min, irmp_param.pulse_0_len_max);
+                            ANALYZE_PRINTF ("error: stop bit timing wrong, ir->bit = %d, ir->isr.pulse_time = %d, pulse_0_len_min = %d, pulse_0_len_max = %d\n",
+                                            ir->bit, ir->isr.pulse_time, ir->param.pulse_0_len_min, ir->param.pulse_0_len_max);
 #endif // ANALYZE
-                            irmp_start_bit_detected = 0;                        // wait for another start bit...
-                            irmp_pulse_time         = 0;
-                            irmp_pause_time         = 0;
+                            ir->isr.start_bit_detected = 0;                        // wait for another start bit...
+                            ir->isr.pulse_time         = 0;
+                            ir->isr.pause_time         = 0;
                         }
                     }
                     else
                     {
-                        irmp_pause_time++;                                                          // increment counter
+                        ir->isr.pause_time++;                                                          // increment counter
 
 #if IRMP_SUPPORT_SIRCS_PROTOCOL == 1
-                        if (irmp_param.protocol == IRMP_SIRCS_PROTOCOL &&                           // Sony has a variable number of bits:
-                            irmp_pause_time > SIRCS_PAUSE_LEN_MAX &&                                // minimum is 12
-                            irmp_bit >= 12 - 1)                                                     // pause too long?
+                        if (ir->param.protocol == IRMP_SIRCS_PROTOCOL &&                           // Sony has a variable number of bits:
+                            ir->isr.pause_time > SIRCS_PAUSE_LEN_MAX &&                                // minimum is 12
+                            ir->bit >= 12 - 1)                                                     // pause too long?
                         {                                                                           // yes, break and close this frame
-                            irmp_param.complete_len = irmp_bit + 1;                                 // set new complete length
+                            ir->param.complete_len = ir->bit + 1;                                 // set new complete length
                             got_light = TRUE;                                                       // this is a lie, but helps (generates stop bit)
-                            irmp_tmp_address |= (irmp_bit - SIRCS_MINIMUM_DATA_LEN + 1) << 8;       // new: store number of additional bits in upper byte of address!
-                            irmp_param.command_end = irmp_param.command_offset + irmp_bit + 1;      // correct command length
-                            irmp_pause_time = SIRCS_PAUSE_LEN_MAX - 1;                              // correct pause length
+                            ir->tmp_address |= (ir->bit - SIRCS_MINIMUM_DATA_LEN + 1) << 8;       // new: store number of additional bits in upper byte of address!
+                            ir->param.command_end = ir->param.command_offset + ir->bit + 1;      // correct command length
+                            ir->isr.pause_time = SIRCS_PAUSE_LEN_MAX - 1;                              // correct pause length
                         }
                         else
 #endif
 #if IRMP_SUPPORT_MERLIN_PROTOCOL == 1
-                        if (irmp_param.protocol == IRMP_MERLIN_PROTOCOL &&                          // Merlin has a variable number of bits:
-                            irmp_pause_time > MERLIN_START_BIT_PAUSE_LEN_MAX &&                     // minimum is 8
-                            irmp_bit >= 8 - 1)                                                      // pause too long?
+                        if (ir->param.protocol == IRMP_MERLIN_PROTOCOL &&                          // Merlin has a variable number of bits:
+                            ir->isr.pause_time > MERLIN_START_BIT_PAUSE_LEN_MAX &&                     // minimum is 8
+                            ir->bit >= 8 - 1)                                                      // pause too long?
                         {                                                                           // yes, break and close this frame
-                            irmp_param.complete_len = irmp_bit;                                     // set new complete length
+                            ir->param.complete_len = ir->bit;                                     // set new complete length
                             got_light = TRUE;                                                       // this is a lie, but helps (generates stop bit)
-                            irmp_pause_time = MERLIN_BIT_PAUSE_LEN_MAX - 1;                         // correct pause length
+                            ir->isr.pause_time = MERLIN_BIT_PAUSE_LEN_MAX - 1;                         // correct pause length
                         }
                         else
 #endif
 #if IRMP_SUPPORT_FAN_PROTOCOL == 1
-                        if (irmp_param.protocol == IRMP_FAN_PROTOCOL &&                             // FAN has no stop bit.
-                            irmp_bit >= FAN_COMPLETE_DATA_LEN - 1)                                  // last bit in frame
+                        if (ir->param.protocol == IRMP_FAN_PROTOCOL &&                             // FAN has no stop bit.
+                            ir->bit >= FAN_COMPLETE_DATA_LEN - 1)                                  // last bit in frame
                         {                                                                           // yes, break and close this frame
-                            if (irmp_pulse_time <= FAN_0_PULSE_LEN_MAX && irmp_pause_time >= FAN_0_PAUSE_LEN_MIN)
+                            if (ir->isr.pulse_time <= FAN_0_PULSE_LEN_MAX && ir->isr.pause_time >= FAN_0_PAUSE_LEN_MIN)
                             {
 #ifdef ANALYZE
                                 ANALYZE_PRINTF ("Generating virtual stop bit\n");
 #endif // ANALYZE
                                 got_light = TRUE;                                                   // this is a lie, but helps (generates stop bit)
                             }
-                            else if (irmp_pulse_time >= FAN_1_PULSE_LEN_MIN && irmp_pause_time >= FAN_1_PAUSE_LEN_MIN)
+                            else if (ir->isr.pulse_time >= FAN_1_PULSE_LEN_MIN && ir->isr.pause_time >= FAN_1_PAUSE_LEN_MIN)
                             {
 #ifdef ANALYZE
                                 ANALYZE_PRINTF ("Generating virtual stop bit\n");
